您的位置:首页 > 编程语言 > C语言/C++

Leetcode-1. Two Sum

2016-05-09 23:53 465 查看
Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution.

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].


 AC代码:o(n^2)

class Solution {
public:
vector<int> twoSum(vector<int>& nums, int target) {
vector<int> re;
for(int i=0; i<nums.size(); i++){
for(int j=i+1; j<nums.size(); j++){
if(target == nums[i]+nums[j]){
re.push_back(i);
re.push_back(j);
break;
}
}
}
return re;
}
};
 AC代码:o(n)   hash table
class Solution {
public:
vector<int> twoSum(vector<int>& nums, int target) {
vector<int> re;
map<int,int> m;
for(int i=0; i<nums.size(); i++)
m.insert(map<int,int>::value_type(nums[i],i));
for(int i=0; i<nums.size(); i++){
int complement=target-nums[i];
map<int,int>::iterator it=m.find(complement);
if(it!=m.end() && it->second!=i){
re.push_back(i);
re.push_back(it->second);
break;
}
}
return re;
}
};

总结:方法1为暴力遍历解法,时间复杂度高,方法二使用了map,空间复杂度提高,但时间复杂度为o(n);

map.find函数返回值为iterator类型,it->first = value,it->second = index.
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  leetcode C++ hash table